#define	NoDigit ' '

void AdjBCD(void)
{
#asm
	movlw   0x03
	addwf   INDF,W
	movwf   temp
	btfsc   temp,3          // test if result > 7
	movwf   INDF
	movlw   0x30
	addwf   INDF,W
	movwf   temp
	btfsc   temp,7          // test if result > 7
	movwf   INDF            // save as MSD
	incf	FSR, F
#endasm
}



//
// Format of result BCD number:
//	bcd[0]	-	MSB
//	bcd[1]
//	bcd[2]	-	LSB
//
void Bin16BCD(int16 ptr,char *str)
{
	// Clear BCD destination string
	FSR = str; 
	INDF = 0; FSR++;		// str[0] = 0;		// MSB
	INDF = 0; FSR++;		// str[1] = 0;
	INDF = 0;				// str[2] = 0;		// LSB
	
	mcnt = 0x10;
	do {
		FSR = &ptr;
#asm
		rlf		INDF,F
		incf	FSR,F
		rlf		INDF,F
#endasm
		FSR = str;	FSR++; FSR++;
#asm
		rlf     INDF, F
		decf	FSR, F
		rlf     INDF, F
		decf	FSR, F
		rlf     INDF, F
#endasm
		if( --mcnt == 0 )
			break;

		FSR = str;
		AdjBCD();
		AdjBCD();
		AdjBCD();

	} while ( 1 );
}

/*
void Bin32BCD(char *src)
{
// Clear BCD destination .
	bcd[0] = 0;	bcd[1] = 0;
	bcd[2] = 0;	bcd[3] = 0;
	bcd[4] = 0;
	mcnt = 0x20;
	do {
		FSR = src;
#asm
		rlf	INDF,F
		incf	FSR,F
		rlf	INDF,F
		incf	FSR,F
		rlf	INDF,F
		incf	FSR,F
		rlf	INDF,F
#endasm
		FSR = &bcd[0] + 4;
#asm
		rlf     INDF, F
		decf	FSR, F
		rlf     INDF, F
		decf	FSR, F
		rlf     INDF, F
		decf	FSR,F
		rlf	INDF,F
		decf	FSR,F
		rlf	INDF,F
#endasm
		if( --mcnt == 0 )
			break;
		FSR = &bcd[0];
		AdjBCD();
		AdjBCD();
		AdjBCD();
		AdjBCD();
		AdjBCD();
	} while ( 1 );
}
*/

void incbcd(char *ptr)
{
char data;
	data = *ptr;
	data += 7;
	if( _DC )
	{
		data -= 6;
		data &= 0xF0;
		swap(data);
		data += 7;
		if( _DC )
			data = 0;
		else
		{
			data -= 6;
			swap(data);
		}
	} else
		data -= 6;
	*ptr = data;
}

char incbcd2(char data)
{
	data += 7;
	if( _DC )
	{
		data -= 6;
		data &= 0xF0;
		swap(data);
		data += 7;
		if( _DC )
			data = 0;
		else
		{
			data -= 6;
			swap(data);
		}
	} else
		data -= 6;
	return data;
}

void incbcd3(char *ptr)
{
char data;
	data = *ptr;
	data += 7;
	if( _DC )
	{
		data -= 6;
		data &= 0xF0;
		swap(data);
		data += 7;
		if( _DC )
			data = 0;
		else
		{
			data -= 6;
			swap(data);
		}
	} else
		data -= 6;
	*ptr = data;
}

