#ifndef __TYPES_H
#define __TYPES_H

/*
	  types.h    
 */

#ifndef uint16
#define uint16	unsigned long
#endif

#ifndef uint8
#define uint8	unsigned int
#endif


typedef struct
{
	char	f1ms:1;
	char	f10ms:1;
	char	f100ms:1;
	char	f1s:1;
	char	t10ms;
	char	t100ms;
	char	t1s;
} RTC;

typedef struct 
{
// LSB  , MSB  
	char 	mRedDisplay;		
	char	mGreenDisplay;
//    (1)    (0)
	char	mShow:1;		
//  mRedColor/mGreenColor  1,    
//  mRedColor/mGreenColor  0,     
	char	mRedColor:1;	
	char	mGreenColor:1;
//  mSynhro   1,          
	char	mSynhro:1;		
	char	mSegments;
//     CD4094  RAM-a
// mBuffer[0] - LSB ,  
// mBuffer[1] - LSB ,  
// mBuffer[2] - MSB ,  
// mBuffer[3] - MSB ,  
	char 	mBuffer[4];		
} Display;


#endif	// __TYPES_H
